package es.fileStore.business.db.impl;

import java.io.Serializable;
import java.util.List;

import javax.annotation.Resource;

import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;



import es.fileStore.bean.FiltroCategorias;
import es.fileStore.business.db.ICategoriasLN;
import es.fileStore.entity.Categorias;
import es.fileStore.business.db.impl.GenericBusinessLogicImpl;
import es.fileStore.dao.ICategoriasDAO;

public class CategoriasLNImpl extends GenericBusinessLogicImpl<Categorias, Serializable> implements ICategoriasLN {

	@Resource(name="categoriasDAO")
	private ICategoriasDAO categoriasDAO;
	
	@Transactional(propagation=Propagation.REQUIRED, rollbackFor=Exception.class)
	public List<Categorias> getListaCategorias(FiltroCategorias filtro) {
		return this.categoriasDAO.getListaCategorias(filtro);
	}
	
	@Transactional(propagation=Propagation.REQUIRED, rollbackFor=Exception.class)
	public Integer altaCategoria(Categorias categoria) {
		
		return this.categoriasDAO.altaCategoria(categoria);
		
	}
	
	@Transactional(propagation=Propagation.REQUIRED, rollbackFor=Exception.class)
	public Categorias getCategoria (Integer idCategoria){
		return this.categoriasDAO.getCategoria(idCategoria);
	}
	
	@Override
	public ICategoriasDAO getDAO() {
		return this.categoriasDAO;
	}
	
}
