package es.fileStore.business.db.impl;

import java.io.Serializable;
import java.util.List;

import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import es.fileStore.dao.IGenericDao;

public abstract class GenericBusinessLogicImpl <T, PK extends Serializable> {

	//private IGenericDao<T, Serializable> dao = getDAO();
	
	public abstract IGenericDao<T, Serializable> getDAO();
	
	public void delete(T entity){
		getDAO().delete(entity);
	}

	@Transactional(propagation=Propagation.REQUIRED, rollbackFor=Exception.class)
	public void deleteById(Serializable id){
		getDAO().deleteById(id);
	}

	public List<T> getList(){
		return getDAO().getList();
	}

	public T load(Serializable id) {
		return getDAO().load(id);
	}

	public T read(Serializable id) {
		return getDAO().read(id);
	}

	@Transactional(propagation=Propagation.REQUIRED, rollbackFor=Exception.class)
	public Serializable save(T entity) {
		return getDAO().save(entity);
	}

	@Transactional(propagation=Propagation.REQUIRED, rollbackFor=Exception.class)
	public void update(T entity) {
		getDAO().update(entity);
	}

}
