package es.fileStore.dao;

import java.io.Serializable;
import java.lang.reflect.ParameterizedType;
import java.lang.reflect.Type;
import java.util.List;

import org.hibernate.Session;
import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

public abstract class  GenericDaoHibernateImpl <T, PK extends Serializable> extends HibernateDaoSupport implements IGenericDao<T, Serializable> {

	private Class<T> entityClass;
	
	
	public GenericDaoHibernateImpl() {
		
		Type type = getClass().getGenericSuperclass();
		
		if (type instanceof ParameterizedType) {
			ParameterizedType paramType = (ParameterizedType)type;
			entityClass = (Class<T>) paramType.getActualTypeArguments()[0];
		}
	}

	public void delete(T entity) {
		super.getSession(false).delete(entity);
	}

	public void deleteById(Serializable id) {
		Session session = super.getSession(false);
		session.delete(session.get(entityClass, id));
	}

	public List<T> getList() {
		List<T> lista = super.getSession(false).createQuery("from " + entityClass.getName()).list();
		return lista;
	}

	public T load(Serializable id) {
		return (T) super.getSession(false).load(entityClass, id);
	}

	public T read(Serializable id) {
		return (T) super.getSession(false).get(entityClass, id);
	}

	public Serializable save(T entity) {
		return super.getSession(false).save(entity);
	}

	public void update(T entity) {
		super.getSession(false).update(entity);
	}

}
