package es.fileStore.dao;

import java.io.Serializable;
import java.util.List;

public interface IGenericDao <T, PK extends Serializable> {

    public PK save(T entity);

    public T read(PK id);

    public T load(PK id);
    
    public void update(T entity);

    public void delete(T entity);
    
    public void deleteById(PK id);

    public List<T> getList();
    
}
