package es.fileStore.dao.impl;

import java.io.Serializable;
import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.Session;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.util.StringUtils;

import es.fileStore.dao.ICategoriasDAO;
import es.fileStore.entity.Categorias;
import es.fileStore.bean.FiltroCategorias;
import es.fileStore.dao.GenericDaoHibernateImpl;

public class CategoriasDAOImpl extends GenericDaoHibernateImpl<Categorias, Serializable> implements ICategoriasDAO {
	
@SuppressWarnings("unchecked")
public List<Categorias> getListaCategorias(FiltroCategorias filtro) {
		
		List<Categorias> resultado = null;
		
		Session session = super.getSession(false);
		
		Criteria criteria = session.createCriteria(Categorias.class);
		
		if ( filtro != null ) {
		
			if (StringUtils.hasText(filtro.getName()) ) {
				
				criteria.add(Restrictions.like("nombreCategoria", filtro.getName() + "%"));
			}
			
		}
		
		criteria.addOrder(Order.asc("nombreCategoria"));
		
		resultado = criteria.list();
		
		return resultado;
		
	}

	public Integer altaCategoria(Categorias categoria) {
		
		Session session = super.getSession(false);
		
		Integer idCategoria = (Integer) session.save(categoria);
				
		return idCategoria;
		
	}
	
	public Categorias getCategoria (Integer idCategoria){
		Categorias resultado = null;
		
		Session session = super.getSession(false);
		
		Criteria criteria = session.createCriteria(Categorias.class);
		
		if (idCategoria != null){
			criteria.add(Restrictions.eq("idCategoria", idCategoria));
			@SuppressWarnings("unchecked")
			List<Categorias> lista = criteria.list();
			if (lista != null && lista.size() == 1){
				resultado = lista.get(0);
			}
		}
		
		return resultado;
	}
	
	
}
