package es.fileStore.dao.impl;

import java.io.Serializable;
import java.util.List;

import org.hibernate.Query;
import org.hibernate.Session;

import es.fileStore.bean.FiltroFicheros;
import es.fileStore.dao.GenericDaoHibernateImpl;
import es.fileStore.dao.IFicherosDAO;
import es.fileStore.entity.Ficheros;
import es.fileStore.view.bean.FicheroBean;

public class FicherosDAOImpl extends GenericDaoHibernateImpl<Ficheros, Serializable> implements IFicherosDAO {

	
	
	public void altaFichero(Ficheros fichero) {
		Session session = super.getSession(false);
		session.save(fichero);
	}
	
	@Override
	public List<FicheroBean> consulta(FiltroFicheros filtro) {
		Session session = super.getSession(false);
		
		
		String order = " order by f.titulo";
		
		String select = ""; 
		
		if ( filtro != null ) {
			select = "select new es.fileStore.view.bean.FicheroBean(f.idFichero, f.categoria.nombreCategoria, f.titulo, f.descripcion, f.rutaFichero, f.usuarioAlta) " +
					" from Ficheros as f ";
				
		}
		
		boolean addAnd = false;
		
		if ( filtro != null ) {
			
				if ( filtro.getIdCategoria() != null && filtro.getIdCategoria() != 0) {
				select += (addAnd?" and ":" where ") + " f.categoria.idCategoria = :idCategoria ";
				addAnd = true;
			}
			
			if(filtro.getTexto() != null && !"".equals(filtro.getTexto())) {
				select += (addAnd?" and ":" where ") + " ( f.titulo like :texto1 ";
				select += " or f.titulo like :texto2 ";
				select += " or f.titulo like :texto3 ";
				select += " or f.descripcion like :texto1 ";
				select += " or f.descripcion like :texto2 ";
				select += " or f.descripcion like :texto3 ";
				select += " or f.usuarioAlta like :texto1 ";
				select += " or f.usuarioAlta like :texto2 ";
				select += " or f.usuarioAlta like :texto3 ) ";
				addAnd = true;
			}
		}
		
		System.out.print(select);
		
		Query query = session.createQuery(select + order);
		
		if ( filtro != null ) {
			
			if ( filtro.getIdCategoria() != null && filtro.getIdCategoria() != 0) {
				
				query.setInteger("idCategoria", filtro.getIdCategoria());
			}
			
			if(filtro.getTexto() != null && !"".equals(filtro.getTexto())) {
				
				query.setString("texto1", "%"+filtro.getTexto()+"%");
				query.setString("texto2", "% "+filtro.getTexto()+"%");
				query.setString("texto3", "%"+filtro.getTexto()+" %");

			}
		}

		List listaFicheros = query.list();
		
		return listaFicheros;
	}
	
	@Override
	public Ficheros detalle(Integer idFichero){
		Session session = super.getSession(false);
		return (Ficheros) session.get(Ficheros.class, idFichero);
	}
	
}
