package es.fileStore.view.controller;

import java.io.Serializable;
import java.util.ResourceBundle;

import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.springframework.web.context.WebApplicationContext;
import org.springframework.web.jsf.FacesContextUtils;

import es.fileStore.business.db.BusinessDBLocator;


public class BaseController implements Serializable {
	
	private static final long serialVersionUID = 1L;
	//Esto es para diferenciar los mensajes de error de los avisos
	public String mensajeControl="error";
	
	public String getMensajeControl() {
		return mensajeControl;
	}

	public void setMensajeControl(String mensajeControl) {
		this.mensajeControl = mensajeControl;
	}
	//////////////////////////////////////////////////////////////

	public FacesContext getFacesContext() {
		return FacesContext.getCurrentInstance();
	}

	public String getUser() {
		
		
		return ( (HttpServletRequest)this.getFacesContext().getExternalContext().getRequest() ).getUserPrincipal().getName();
	}
	
	public void addMenssage(String clientId, FacesMessage menssage) {
		this.getFacesContext().addMessage(clientId, menssage);
	}

	public String getRequestParam(String paramName) {
		return this.getFacesContext().getExternalContext()
				.getRequestParameterMap().get(paramName);
	}
	
	public void setRequestParam(String paramName, Object parameter) {
		this.getFacesContext().getExternalContext()
		.getRequestMap().put(paramName, parameter);
	}

	public Object getSessionParam(String paramName) {
		return this.getFacesContext().getExternalContext().getSessionMap().get(
				paramName);
	}
	
	public void setSessionParam(String paramName, Object parameter) {
		((HttpSession) this.getFacesContext().getExternalContext().getSession(false)).setAttribute(paramName, parameter);
	}
	
	public void deleteSessionParam(String paramName) {
		this.getFacesContext().getExternalContext().getSessionMap().remove(paramName);
	}

	public HttpSession getSession(boolean create) {
		return (HttpSession) this.getFacesContext().getExternalContext()
				.getSession(create);
	}

	public BusinessDBLocator getBusinessDBLocator(){
		
		WebApplicationContext context = FacesContextUtils
				.getWebApplicationContext(this.getFacesContext());

		return (BusinessDBLocator) context.getBean("businessDBLocator");
	}
	
	public Object getSpringBean(String idBean) throws Exception {
		
		return FacesContextUtils.getWebApplicationContext(this.getFacesContext()).getBean(idBean);
	}
	
	
	protected String getActionAttribute(ActionEvent event, String attribute){
		return (String) event.getComponent().getAttributes().get(attribute).toString();

	}

	public ResourceBundle getResourceBundle() {
		
		return ResourceBundle.getBundle(this.getFacesContext().getApplication()
				.getMessageBundle(), this.getFacesContext().getViewRoot().getLocale());
		
	}
	
}